//
//  For more information, please see: http://software.sci.utah.edu
//
//  The MIT License
//
//  Copyright (c) 2009 Scientific Computing and Imaging Institute,
//  University of Utah.
//
//
//  Permission is hereby granted, free of charge, to any person obtaining a
//  copy of this software and associated documentation files (the "Software"),
//  to deal in the Software without restriction, including without limitation
//  the rights to use, copy, modify, merge, publish, distribute, sublicense,
//  and/or sell copies of the Software, and to permit persons to whom the
//  Software is furnished to do so, subject to the following conditions:
//
//  The above copyright notice and this permission notice shall be included
//  in all copies or substantial portions of the Software.
//
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
//  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
//  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
//  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
//  DEALINGS IN THE SOFTWARE.
//
//    File   : EventSpawner.h
//    Author : McKay Davis
//    Date   : Fri Jun  2 13:41:27 MDT 2006

#ifndef CORE_EVENTS_EVENTSPAWNER_H
#define CORE_EVENTS_EVENTSPAWNER_H

#include <Core/Util/ThrottledRunnable.h>
#include <string>

namespace SCIRun {
  class Semaphore;
  class EventSpawner : public SCIRun::ThrottledRunnable {
  public:
    virtual bool        iterate() = 0;
  protected:
    EventSpawner(const std::string &target) :
      ThrottledRunnable(200.0),
      target_(target) {}
    virtual ~EventSpawner() {}
    std::string         target_;
  };
}

#endif
